       IDENTIFICATION DIVISION.
       PROGRAM-ID.    BSDCOBCL.
       AUTHOR.        CSI.
       DATE-WRITTEN.  NOV 2007.
      ******************************************************************
      *                                                                *
      * THIS SOURCE MODULE IS PART OF A SET OF MODULES THAT REPRESENT  *
      * A SAMPLE BSD/C SERVER THAT RUNS IN CICS.                       *
      *                                                                *
      * THE SET OF MODULES INCLUDE THE FOLLOWING:                      *
      *                                                                *
      *  BSDCOBCL - MAIN LISTEN TASK                                   *
      *  BSDCOBCS - SERVER TASK THAT PROCESSES THE CONNECTED TASK(S)   *
      *  BSDCOBCX - TASK TO START/STOP THE LISTEN AND SERVER TASKS     *
      *  BSDCOBCT - TABLE TO CONTAIN COMMON FIELDS                     *
      *                                                                *
      *  REQUIRED CICS DEFINITIONS                                     *
      *  -------------------------                                     *
      *    CEDA DEFINE GROUP(BSDC) PROGRAM(BSDCOBCT) LANG(ASSEM)       *
      *    CEDA DEFINE GROUP(BSDC) PROGRAM(BSDCOBCL) LANG(COBOL)       *
      *    CEDA DEFINE GROUP(BSDC) PROGRAM(BSDCOBCX) LANG(COBOL)       *
      *    CEDA DEFINE GROUP(BSDC) PROGRAM(BSDCOBCS) LANG(COBOL)       *
      *    CEDA DEFINE GROUP(BSDC) TRANS(BSDX) PROGRAM(BSDCOBCX)       *
      *    CEDA DEFINE GROUP(BSDC) TRANS(BSDL) PROGRAM(BSDCOBCL)       *
      *    CEDA DEFINE GROUP(BSDC) TRANS(BSDS) PROGRAM(BSDCOBCS)       *
      *                                                                *
      *                                                                *
      *  BSDCOBCL                                                      *
      *                                                                *
      *  THIS PROGRAM IS THE MAIN 'LISTEN' TASK THAT OPENS A SOCKET    *
      *  AND WAITS FOR A CONNECTION FROM A CLIENT.                     *
      *                                                                *
      *  THIS SAMPLE PROGRAM LISTENS ON PORT: 6045                     *
      *                                                                *
      *  WHEN A CONNECTION IS MADE, IT 'STARTS' PROGRAM BSDCOBCS WHICH *
      *  WILL HANDLE THE ACTUAL PROCESSING OF THE CLIENT REQUESTS.     *
      *                                                                *
      *  THIS PROGRAM ASSUMES CICS TRANSATION 'BSDS' HAS BEEN DEFINED  *
      *  FOR PROGRAM BSDCOBCS.                                         *
      *                                                                *
      *  THIS PROGRAM THAN RETURNS TO THE LISTEN STATE WAITING FOR     *
      *  ANOTHER CONNECTION.                                           *
      *                                                                *
      *  THERE ARE MANY DISPLAY COMMANDS IN THIS SAMPLE PROGRAM THAT   *
      *  WOULD NOT NORMALLY BE IN A PRODUCTION SYSTEM. THEY ARE HERE   *
      *  TO HELP ILLUSTRATE WHAT THE PROGRAM IS DOING.                 *
      *                                                                *
      ******************************************************************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
 
       01  WS-EYE PIC X(24) VALUE 'BSDCOBCL-WORKING-STORAGE'.
       01  TCPIP-CONSTANTS.
      *        SOCKET.H AF_INET
           05  SOCKET-DOMAIN            PIC S9(8) COMP VALUE +2.                N19990622 16:54:09
      *        SOCKET.H SOCK_STREAM
           05  SOCKET-TYPE              PIC S9(8) COMP VALUE +1.                N19990622 16:54:09
      *        SOCKET.H IPPROTO_TCP
           05  SOCKET-PROTOCOL          PIC S9(8) COMP VALUE +2.                N19990622 16:54:09
           05  MAX-SOCKETS              PIC S9(8) COMP VALUE +128.
           05  MAX-BACKLOG              PIC S9(8) COMP VALUE +3.
 
       01  TCPIP-FIELDS.
           05  TCPIP-TIMEOUT.
               10  TCPIP-TIMEOUT-SECS   PIC S9(8) COMP VALUE +99999.
               10  TCPIP-TIMEOUT-USECS  PIC S9(8) COMP VALUE +0.
           05  TCPIP-SOCKET             PIC S9(8) COMP VALUE +0.                N19990622 16:54:09
           05  TCPIP-ACCEPT-SOCKET      PIC S9(8) COMP VALUE +0.                N19990622 16:54:09
           05  TCPIP-SENDBUFF-LEN       PIC S9(8) COMP VALUE +80.               N19990622 16:54:09
           05  TCPIP-SENDBUFF           PIC X(80).
           05  TCPIP-RECVBUFF-LEN       PIC S9(8) COMP VALUE +80.               N19990622 16:54:09
           05  TCPIP-RECVBUFF           PIC X(80).
           05  TCPIP-LEN                PIC S9(4) COMP VALUE +0.                N19990622 16:54:09
           05  TCPIP-SOCKET-ACQ         PIC X          VALUE 'N'.
           05  TCPIP-MASK-READ          PIC X(16) VALUE LOW-VALUES.
           05  TCPIP-MASK-WRITE         PIC X(16) VALUE LOW-VALUES.
           05  TCPIP-MASK-EXCP          PIC X(16) VALUE LOW-VALUES.
 
       01  TCPIP-DUMMY-ECB              PIC X(4)  VALUE LOW-VALUES.
 
       01  TCPIP-SOCKADDR.
           05  FILLER                   PIC S9(4) COMP VALUE +2.                N19990622 16:54:09
           05  SOCKADDR-PORT            PIC S9(4) COMP VALUE +6045.             N19990622 16:54:09
           05  SOCKADDR-IPADDR          PIC X(4)  VALUE LOW-VALUES.             N19990622 16:54:09
           05  FILLER                   PIC X(8)  VALUE LOW-VALUES.
       01  TCPIP-SOCKADDR-LEN           PIC S9(8) COMP VALUE +16.               N19990622 16:54:09
 
       01  TCPIP-IPNRVERS               PIC X(8)  VALUE LOW-VALUES.             N19990622 16:54:09
       01  TCPIP-IPNRVERS-LEN           PIC S9(8) COMP VALUE +8.                N19990622 16:54:09
 
       01  TCPIP-PEERSOCK.
           05  FILLER                   PIC X(2)  VALUE LOW-VALUES.             N19990622 16:54:09
           05  PEERSOCK-PORT            PIC S9(4) COMP VALUE +0.                N19990622 16:54:09
           05  PEERSOCK-IPADDR          PIC X(4)  VALUE LOW-VALUES.             N19990622 16:54:09
           05  FILLER                   PIC X(8)  VALUE LOW-VALUES.
       01  TCPIP-PEERSOCK-LEN           PIC S9(8) COMP VALUE +16.               N19990622 16:54:09
 
       01  MISC-WS.
           05  WS-START                 PIC XX.
           05  DISPLAY-RC               PIC ZZZZZZZ9-.
 
       01  BIT-WORK-AREAS.
           05 BIT-BITS                  PIC X(8) VALUE
                                          X'8040201008040201'.
           05 BIT-MASK-OFFSET           PIC S9(4) COMP VALUE +0.
           05 BIT-BIT-OFFSET            PIC S9(4) COMP VALUE +0.
 
       01  IP-DISPLAY.
           05 IPD-1                     PIC 999.
           05 FILLER                    PIC X VALUE '.'.
           05 IPD-2                     PIC 999.
           05 FILLER                    PIC X VALUE '.'.
           05 IPD-3                     PIC 999.
           05 FILLER                    PIC X VALUE '.'.
           05 IPD-4                     PIC 999.
 
       01  IPWORK.
           05 IP-1                      PIC 9(4) COMP.
           05 IP-2                      PIC 9(4) COMP.
           05 IP-3                      PIC 9(4) COMP.
           05 IP-4                      PIC 9(4) COMP.
 
       LINKAGE SECTION.
 
      ******************************************************************
      *                                                                *
      *    BSDCOBCT TABLE  - LOADED FROM BSDCOBCT                      *
      *                                                                *
      *    THE FORMAT OF THIS TABLE IS KNOWN BY PROGRAMS:              *
      *                                                                *
      *    BSDCOBCL - SAMPLE COBOL BSD/C SERVER LISTEN TASK            *
      *    BSDCOBCS - SAMPLE COBOL BSD/C SERVER PROCESS TASK           *
      *    BSDCOBCX - SAMPLE COBOL BSD/C SERVER TERMINATION TASK       *
      *                                                                *
      ******************************************************************
 
       01  BSDCOBCT-TABLE.
           05  BSDCOBCT-EYECATCHER          PIC X(16).
           05  BSDCOBCT-ERRNO               PIC S9(8) COMP.                     N19990622 16:54:09
           05  BSDCOBCT-RETCODE             PIC S9(8) COMP.                     N19990622 16:54:09
      *    ECB MUST START ON FULL-WORD
           05  BSDCOBCT-TERM-ECB            PIC X(4).
           05  BSDCOBCT-TERM-FLAG           PIC X.
 
      ******************************************************************
      *                                                                *
      *    START OF PROCEDURE DIVISION.                                *
      *                                                                *
      ******************************************************************
 
       PROCEDURE DIVISION.
           DISPLAY 'BSDCOBCL ENTRY'.
 
      ******************************************************************
      *
      *    LOAD COMMON CONTROL TABLE
      *
           DISPLAY 'BSDCOBCL LOADING BSDCOBCT'.
           EXEC CICS LOAD PROGRAM('BSDCOBCT') NOHANDLE
                              SET(ADDRESS OF BSDCOBCT-TABLE) END-EXEC.
 
           IF EIBRESP IS NOT = ZERO
               DISPLAY 'BSDCOBCL LOAD OF BSDCOBCT FAILED, RC='
                       EIBRESP
               GO TO 90000-EXIT-CICS
           ELSE
               DISPLAY BSDCOBCT-EYECATCHER
           END-IF.
 
           IF BSDCOBCT-TERM-FLAG = 'X'
               DISPLAY 'BSDCOBCL TERMINATE REQUESTED'
               GO TO 90000-EXIT-CICS
           END-IF.
 
      ******************************************************************
      *
      * * BSD-C GET TCP VERS CALL...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRVERS'.
           CALL 'IPNRVERS' USING TCPIP-IPNRVERS, TCPIP-IPNRVERS-LEN.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL STACK VERS=' TCPIP-IPNRVERS ' RC='
                    DISPLAY-RC.
 
      ******************************************************************
      *
      * * BSD-C SETERRD() CALL INVOKES IPNRERRD...
      *
      *   THIS FUNCTION SETS 'DEFAULT' LOCATIONS FOR RETURNING THE
      *   TCPIP ERRNO AND RETCODE FIELDS
      *
           DISPLAY 'BSDCOBCL CALLING IPNRERRD'.
           CALL 'IPNRERRD' USING BSDCOBCT-ERRNO, BSDCOBCT-RETCODE.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                        ' RETCODE=' BSDCOBCT-RETCODE
                        ' ERRNO=' BSDCOBCT-ERRNO
                        ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
 
      ******************************************************************
      *
      * * BSD-C SOCKET() CALL INVOKES IPNRSOCK...
      *
      *    RETURNS LISTEN SOCKET NUMBER IN RETURN-CODE FIELD
      *
           DISPLAY 'BSDCOBCL CALLING IPNRSOCK'.
           CALL 'IPNRSOCK' USING SOCKET-DOMAIN,
                                 SOCKET-TYPE,
                                 SOCKET-PROTOCOL.
           MOVE RETURN-CODE TO TCPIP-SOCKET.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                        ' RETCODE=' BSDCOBCT-RETCODE
                        ' ERRNO=' BSDCOBCT-ERRNO
                        ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
           IF RETURN-CODE IS LESS THAN ZERO
               GO TO 50000-CLOSE-TCP
           ELSE
               MOVE 'Y' TO TCPIP-SOCKET-ACQ
           END-IF.
 
      ******************************************************************
      *
      * * BSD-C BIND() CALL INVOKES IPNRBIND...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRBIND, SOCKET='
                   TCPIP-SOCKET ' PORT=' SOCKADDR-PORT.
           CALL 'IPNRBIND' USING TCPIP-SOCKET,
                                 TCPIP-SOCKADDR,
                                 TCPIP-SOCKADDR-LEN.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
           IF RETURN-CODE IS LESS THAN ZERO
               GO TO 50000-CLOSE-TCP.
 
      ******************************************************************
      *
      * * BSD-C LISTEN() CALL INVOKES IPNRLIST...
      * * THIS WILL CAUSE A PASSIVE OPEN TO BE ISSUED...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRLIST, SOCKET='
                   TCPIP-SOCKET.
           CALL 'IPNRLIST' USING TCPIP-SOCKET,
                                 MAX-BACKLOG.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
           IF RETURN-CODE IS LESS THAN ZERO
               GO TO 50000-CLOSE-TCP.
 
      ******************************************************************
      *
      * * BSD-C GETSOCKETNAME() CALL INVOKES IPNRGETS...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRGETS, SOCKET='
                   TCPIP-SOCKET.
           CALL 'IPNRGETS' USING TCPIP-SOCKET,
                                 TCPIP-SOCKADDR,
                                 TCPIP-SOCKADDR-LEN.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
 
           MOVE LOW-VALUES TO IPWORK.
           MOVE SOCKADDR-IPADDR(1:1) TO IPWORK(2:1).
           MOVE SOCKADDR-IPADDR(2:1) TO IPWORK(4:1).
           MOVE SOCKADDR-IPADDR(3:1) TO IPWORK(6:1).
           MOVE SOCKADDR-IPADDR(4:1) TO IPWORK(8:1).
           MOVE IP-1 TO IPD-1.
           MOVE IP-2 TO IPD-2.
           MOVE IP-3 TO IPD-3.
           MOVE IP-4 TO IPD-4.
 
           DISPLAY 'BSDCOBCL LISTEN ACTIVE ON ' IP-DISPLAY
                                   ' PORT ' SOCKADDR-PORT.
 
      ******************************************************************
      *                                                                *
      *   LOOP HERE TO WAIT FOR EACH NEW INCOMING CONNECTION           *
      *                                                                *
      ******************************************************************
 
       30000-SELECTEX.
 
           IF BSDCOBCT-TERM-FLAG = 'X'
               DISPLAY 'BSDCOBCL TERMINATE REQUESTED'
               GO TO 50000-CLOSE-TCP
           END-IF.
 
      ******************************************************************
      *
      * * BSD-C SELECTEX() FUNCTION CALL...
      * * THIS WILL ISSUE A WAIT...BSD-C CALLS THIS BLOCKING.
      * * UNTIL A SOMEONE CONNECTS TO IT...
      *
      *    FIRST SET BIT IN READ MASK FOR LISTEN SOCKET NUMBER
      *
           DIVIDE TCPIP-SOCKET BY 8 GIVING BIT-MASK-OFFSET
                                 REMAINDER BIT-BIT-OFFSET.
           ADD +1 TO BIT-MASK-OFFSET.
           ADD +1 TO BIT-BIT-OFFSET.
           MOVE LOW-VALUES TO TCPIP-MASK-READ.
           MOVE BIT-BITS (BIT-BIT-OFFSET:1) TO
                TCPIP-MASK-READ (BIT-MASK-OFFSET:1).
           DISPLAY 'BSDCOBCL MOFF=' BIT-MASK-OFFSET
                           ' BOFF=' BIT-BIT-OFFSET
                           ' MASK=' TCPIP-MASK-READ.
 
           DISPLAY 'BSDCOBCL CALLING IPNRSELX'.
           CALL 'IPNRSELX' USING MAX-SOCKETS,
                                 TCPIP-MASK-READ,
                                 TCPIP-MASK-WRITE,
                                 TCPIP-MASK-EXCP,
                                 TCPIP-TIMEOUT,
                                 BSDCOBCT-TERM-ECB,
                                 TCPIP-DUMMY-ECB.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
 
           IF BSDCOBCT-TERM-FLAG = 'X'
               DISPLAY 'BSDCOBCL TERMINATE REQUESTED'
               GO TO 50000-CLOSE-TCP
           END-IF.
 
           IF RETURN-CODE IS LESS THAN ZERO
               DISPLAY 'BSDCOBCL CONNECTION FAILED'
               GO TO 50000-CLOSE-TCP
           END-IF.
 
           IF TCPIP-MASK-READ = LOW-VALUES
               DISPLAY 'BSDCOBCL TIMEOUT EXPIRED'
               GO TO 30000-SELECTEX
           END-IF.
 
      ******************************************************************
      *
      * * BSD-C ACCEPT() FUNCTION CALL...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRACCP'.
           CALL 'IPNRACCP' USING TCPIP-SOCKET,
                                 TCPIP-SOCKADDR,
                                 TCPIP-SOCKADDR-LEN.
           MOVE RETURN-CODE TO TCPIP-ACCEPT-SOCKET.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
 
           IF RETURN-CODE IS LESS THAN ZERO
               GO TO 50000-CLOSE-TCP.
 
      ******************************************************************
      *
      * * BSD-C GETSOCKETNAME() CALL INVOKES IPNRGETS...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRGETS, SOCKET='
                   TCPIP-ACCEPT-SOCKET.
           CALL 'IPNRGETS' USING TCPIP-ACCEPT-SOCKET,
                                 TCPIP-SOCKADDR,
                                 TCPIP-SOCKADDR-LEN.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
 
           MOVE LOW-VALUES TO IPWORK.
           MOVE SOCKADDR-IPADDR(1:1) TO IPWORK(2:1).
           MOVE SOCKADDR-IPADDR(2:1) TO IPWORK(4:1).
           MOVE SOCKADDR-IPADDR(3:1) TO IPWORK(6:1).
           MOVE SOCKADDR-IPADDR(4:1) TO IPWORK(8:1).
           MOVE IP-1 TO IPD-1.
           MOVE IP-2 TO IPD-2.
           MOVE IP-3 TO IPD-3.
           MOVE IP-4 TO IPD-4.
 
           DISPLAY 'BSDCOBCL CONNECTION ON ' IP-DISPLAY
                                       ' PORT ' SOCKADDR-PORT.
 
      ******************************************************************
      *
      * * BSD-C GETPEERNAME() CALL INVOKES IPNRGETP...
      *
           DISPLAY 'BSDCOBCL CALLING IPNRGETP, SOCKET='
                   TCPIP-ACCEPT-SOCKET.
           CALL 'IPNRGETP' USING TCPIP-ACCEPT-SOCKET,
                                 TCPIP-PEERSOCK,
                                 TCPIP-PEERSOCK-LEN.
           MOVE RETURN-CODE TO DISPLAY-RC.
           DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                   ' RETCODE=' BSDCOBCT-RETCODE
                   ' ERRNO=' BSDCOBCT-ERRNO
                   ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2.
 
           MOVE LOW-VALUES TO IPWORK.
           MOVE PEERSOCK-IPADDR(1:1) TO IPWORK(2:1).
           MOVE PEERSOCK-IPADDR(2:1) TO IPWORK(4:1).
           MOVE PEERSOCK-IPADDR(3:1) TO IPWORK(6:1).
           MOVE PEERSOCK-IPADDR(4:1) TO IPWORK(8:1).
           MOVE IP-1 TO IPD-1.
           MOVE IP-2 TO IPD-2.
           MOVE IP-3 TO IPD-3.
           MOVE IP-4 TO IPD-4.
 
           DISPLAY 'BSDCOBCL CONNECTION WITH ' IP-DISPLAY
                                       ' PORT ' PEERSOCK-PORT.
 
      ******************************************************************
      *
      * * ISSUE CICS START OF ACTUAL 'SERVER' FUNCTION
      *
           EXEC CICS START TRANSID('BSDS') INTERVAL(0)
                           FROM(TCPIP-ACCEPT-SOCKET)
                           LENGTH(4) NOHANDLE
           END-EXEC.
 
           GO TO 30000-SELECTEX.
 
       50000-CLOSE-TCP.
 
      ******************************************************************
      *
      * * BSD-C CLOSE FUNCTION CALL... FOR MAIN LISTEN SOCKET
      *
           IF TCPIP-SOCKET-ACQ = 'Y'
               DISPLAY 'BSDCOBCL CALLING IPNRCLOS, SOCKET='
                       TCPIP-SOCKET
               CALL 'IPNRCLOS' USING TCPIP-SOCKET
               MOVE RETURN-CODE TO DISPLAY-RC
               DISPLAY 'BSDCOBCL RC=' DISPLAY-RC
                       ' RETCODE=' BSDCOBCT-RETCODE
                       ' ERRNO=' BSDCOBCT-ERRNO
                       ' EIBRESP=' EIBRESP ' EIBRESP2=' EIBRESP2
           END-IF.
      *
       90000-EXIT-CICS.
           EXEC CICS ASSIGN STARTCODE(WS-START) END-EXEC.
           IF WS-START (1:1) = 'T'
               EXEC CICS SEND FROM(WS-EYE) LENGTH(0) ERASE END-EXEC
           END-IF.
 
           DISPLAY 'BSDCOBCL EXIT'.
           MOVE ZERO TO RETURN-CODE.
           EXEC CICS RETURN END-EXEC.                                   00242000
